function removetabs_removeleft(usecontext) {
	var tabs = gBrowser.tabContainer;
	var ctab = (usecontext ? gBrowser.mContextTab : gBrowser.selectedTab);
	var i;
	for(i=tabs.childNodes.length-1; tabs.childNodes[i] != ctab; i--){}
	for(i--; i>=0; i--){
		gBrowser.removeTab(tabs.childNodes[i]);
	}
	removetabs_updateEnabled();
}

function removetabs_removeright(usecontext) {
	var tabs = gBrowser.tabContainer;
	var ctab = (usecontext ? gBrowser.mContextTab : gBrowser.selectedTab);
	for(var i=tabs.childNodes.length-1; tabs.childNodes[i] != ctab; i--){
		gBrowser.removeTab(tabs.childNodes[i]);
	}
	removetabs_updateEnabled();
}

function removetabs_removeother(usecontext) {
	var ctab = (usecontext ? gBrowser.mContextTab : gBrowser.selectedTab);
	gBrowser.removeAllTabsBut(ctab);
	removetabs_updateEnabled();
}

function removetabs_removeall(usecontext) {
	var ctab = gBrowser.addTab(removetabs_getRemoveallPage());
	gBrowser.removeAllTabsBut(ctab);
	if(gBrowser.tabContainer.childNodes.length > 1) {
		gBrowser.removeTab(ctab);
	}
	removetabs_updateEnabled();
}

function removetabs_getRemoveallPage() {
	var prefSvc = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService);
	var prefBranch = prefSvc.getBranch("extensions.removetabs.");

	switch(prefBranch.getIntPref("removeall_type")) {
	case 0:
		return "about:blank";
	case 1:
		return gBrowser.homePage;
	case 2:
		return prefBranch.getCharPref("removeall_url");
	default:
		return "about:blank";
	}
}

function removetabs_setDisabled(id, value) {
	var item = gBrowser.ownerDocument.getElementById(id);
	if(item == null){ return; }
	item.setAttribute("disabled", value);
}

function removetabs_updateEnabled() {
	var tabs = gBrowser.tabContainer;
	removetabs_setDisabled("tab-removeleftmenu",
		(tabs.childNodes[0] == gBrowser.mContextTab));
	removetabs_setDisabled("tab-removerightmenu",
		(tabs.childNodes[tabs.childNodes.length-1] == gBrowser.mContextTab));
	removetabs_setDisabled("tab-removeallmenu",
		(tabs.childNodes.length <= 1 && 
		 gBrowser.currentURI.spec == "about:blank"));
	removetabs_setDisabled("removeleftbutton",
		(tabs.childNodes[0] == gBrowser.selectedTab));
	removetabs_setDisabled("removerightbutton",
		(tabs.childNodes[tabs.childNodes.length-1] == gBrowser.selectedTab));
	removetabs_setDisabled("removeotherbutton",
		(tabs.childNodes.length <= 1));
	removetabs_setDisabled("removeallbutton",
		(tabs.childNodes.length <= 1 && 
		 gBrowser.currentURI.spec == "about:blank"));
}

function removetabs_addMenuItem(browser, menuid) {
	if(!browser){ return; }
	var removetabsMenu = browser.ownerDocument.getElementById(menuid).cloneNode(false);
	if(!removetabsMenu){ return; }
	removetabsMenu.id = "tab-" + menuid;
	var menuParent = browser.mStrip.firstChild.nextSibling;
	var pos = 4;
	if(pos >= menuParent.childNodes.length){
	  menuParent.appendChild(removetabsMenu);
	}else{
	  menuParent.insertBefore(removetabsMenu, menuParent.childNodes[pos]);
	}
}

function removetabs_addMenuItems(browser) {
	var prefSvc = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService);
	var prefBranch = prefSvc.getBranch("extensions.removetabs.");

	if(prefBranch.getBoolPref("add_removeleft_menu")) {
		removetabs_addMenuItem(browser, "removeleftmenu");
	}
	if(prefBranch.getBoolPref("add_removeright_menu")) {
		removetabs_addMenuItem(browser, "removerightmenu");
	}
	if(prefBranch.getBoolPref("add_removeall_menu")) {
		removetabs_addMenuItem(browser, "removeallmenu");
	}
}

function removetabs_init() {
	if(!gBrowser){ return; }
	removetabs_addMenuItems(gBrowser);

	var menuParent = gBrowser.mStrip.firstChild.nextSibling;
	menuParent.addEventListener("popupshowing", removetabs_updateEnabled, false);
	var contentArea = gBrowser.ownerDocument.getElementById("appcontent");
	contentArea.addEventListener("load", removetabs_updateEnabled, true);
	contentArea.addEventListener("select", removetabs_updateEnabled, false);
	contentArea.addEventListener("unload", removetabs_updateEnabled, true);
	removetabs_updateEnabled();
}
